#!/usr/bin/perl -w  # -*- cperl -*- #
#
#  uptime.pm - Handle the "uptime" command.
#
#  Steve Kemp
#  ---
#  http://www.steve.org.uk/
#
#


#
#  The package this module is implementing.
#
package Xen::Monitor::Plugins::uptime;


#
#  Register the plugin.
#
Xen::Monitor::Server::register_plugin("Xen::Monitor::Plugins::uptime");



#
#  Minimal constructor.
#
sub new { return bless {}; }



#
#  Return the author of this plugin.
#
sub getAuthor
{
    return( 'Steve Kemp <steve@steve.org.uk>' );
}


#
#  Does this plugin require authentication?
#
sub needsAuth
{
    return 1;
}

#
#  Return the commands we handle.
#
sub getCommand
{
    my %commands;
    $commands{"uptime"} = 1;
    return( %commands );
}


#
# Run the command we're sent - this means 'uptime'.
#
sub runCommand
{
    my ( $class, $server, $command, @args ) = ( @_ );

    my $host = shift( @args );

    if ( !defined( $host ) )
    {
	print "400 MISSING HOST\r\n";
	return;
    }

    if ( ! $server->canControl( $host ) )
    {
	print "400 NOT ALLOWED\r\n";
	return;
    }

    my $instance = Xen::Host->new( name => $host );

    print "200 OK\r\n";
    print $instance->getUptime() . "\r\n";
    print "300 DONE\r\n";
}


1;
